/* postler-accounts.c generated by valac 0.13.1, the Vala compiler
 * generated from postler-accounts.vala, do not modify */

/*
 Copyright (C) 2011 Christian Dywan <christian@twotoasts.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <glib/gstdio.h>
#include <sys/stat.h>


#define POSTLER_TYPE_ACCOUNT_TYPE (postler_account_type_get_type ())

#define POSTLER_TYPE_FOLDER_TYPE (postler_folder_type_get_type ())

#define POSTLER_TYPE_MAIL_FOLDER (postler_mail_folder_get_type ())
typedef struct _PostlerMailFolder PostlerMailFolder;
#define _g_free0(var) (var = (g_free (var), NULL))

#define POSTLER_TYPE_ACCOUNT_INFO (postler_account_info_get_type ())
#define POSTLER_ACCOUNT_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POSTLER_TYPE_ACCOUNT_INFO, PostlerAccountInfo))
#define POSTLER_ACCOUNT_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POSTLER_TYPE_ACCOUNT_INFO, PostlerAccountInfoClass))
#define POSTLER_IS_ACCOUNT_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POSTLER_TYPE_ACCOUNT_INFO))
#define POSTLER_IS_ACCOUNT_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POSTLER_TYPE_ACCOUNT_INFO))
#define POSTLER_ACCOUNT_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POSTLER_TYPE_ACCOUNT_INFO, PostlerAccountInfoClass))

typedef struct _PostlerAccountInfo PostlerAccountInfo;
typedef struct _PostlerAccountInfoClass PostlerAccountInfoClass;
typedef struct _PostlerAccountInfoPrivate PostlerAccountInfoPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define POSTLER_TYPE_ACCOUNTS (postler_accounts_get_type ())
#define POSTLER_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POSTLER_TYPE_ACCOUNTS, PostlerAccounts))
#define POSTLER_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POSTLER_TYPE_ACCOUNTS, PostlerAccountsClass))
#define POSTLER_IS_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POSTLER_TYPE_ACCOUNTS))
#define POSTLER_IS_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POSTLER_TYPE_ACCOUNTS))
#define POSTLER_ACCOUNTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POSTLER_TYPE_ACCOUNTS, PostlerAccountsClass))

typedef struct _PostlerAccounts PostlerAccounts;
typedef struct _PostlerAccountsClass PostlerAccountsClass;
typedef struct _PostlerAccountsPrivate PostlerAccountsPrivate;
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))

typedef enum  {
	POSTLER_ACCOUNT_TYPE_MAILDIR,
	POSTLER_ACCOUNT_TYPE_IMAP,
	POSTLER_ACCOUNT_TYPE_SEARCH
} PostlerAccountType;

typedef enum  {
	POSTLER_FOLDER_TYPE_INBOX,
	POSTLER_FOLDER_TYPE_SENT,
	POSTLER_FOLDER_TYPE_DRAFTS,
	POSTLER_FOLDER_TYPE_QUEUE,
	POSTLER_FOLDER_TYPE_TRASH,
	POSTLER_FOLDER_TYPE_ARCHIVE,
	POSTLER_FOLDER_TYPE_JUNK,
	POSTLER_FOLDER_TYPE_GENERIC,
	POSTLER_FOLDER_TYPE_MAX
} PostlerFolderType;

struct _PostlerMailFolder {
	gchar* role;
	gchar* stock_id;
	gchar* label;
	gchar** localized;
	gint localized_length1;
	gint n_localized;
	PostlerFolderType type;
	gint i_type;
};

struct _PostlerAccountInfo {
	GObject parent_instance;
	PostlerAccountInfoPrivate * priv;
	gchar* name;
	gchar* display_name;
	PostlerAccountType type;
	gchar* realname;
	gchar* address;
	gchar* receive;
	gchar* send;
	gint send_port;
	gchar* username;
	gchar* password;
	gchar* prefix;
	gchar* path;
	gchar* certificate;
	gboolean unverified;
	gchar* reply;
	gchar* organization;
	gchar* signature;
	gchar* hide;
	gchar** folders;
	gint folders_length1;
};

struct _PostlerAccountInfoClass {
	GObjectClass parent_class;
};

typedef void (*PostlerAccountInfoMailFolderCallback) (gint type, PostlerMailFolder* folder, void* user_data);
struct _PostlerAccounts {
	GObject parent_instance;
	PostlerAccountsPrivate * priv;
};

struct _PostlerAccountsClass {
	GObjectClass parent_class;
	void (*add_info) (PostlerAccounts* self, PostlerAccountInfo* info);
	void (*remove_info) (PostlerAccounts* self, PostlerAccountInfo* info);
};

struct _PostlerAccountsPrivate {
	gchar* config_path;
	gchar* account_file;
	gchar* data_path;
	gchar* certificate_file;
	GKeyFile* keyfile;
	GList* infos;
};


static gpointer postler_account_info_parent_class = NULL;
static gpointer postler_accounts_parent_class = NULL;

GType postler_account_type_get_type (void) G_GNUC_CONST;
GType postler_folder_type_get_type (void) G_GNUC_CONST;
gchar* postler_folder_type_get_stock_id (PostlerFolderType self);
GType postler_mail_folder_get_type (void) G_GNUC_CONST;
PostlerMailFolder* postler_mail_folder_dup (const PostlerMailFolder* self);
void postler_mail_folder_free (PostlerMailFolder* self);
void postler_mail_folder_copy (const PostlerMailFolder* self, PostlerMailFolder* dest);
void postler_mail_folder_destroy (PostlerMailFolder* self);
#define POSTLER_STOCK_INBOX "mail-inbox"
#define POSTLER_STOCK_SENT_MAIL "mail-sent"
#define POSTLER_STOCK_OUTBOX "mail-outbox"
#define POSTLER_STOCK_USER_TRASH "user-trash"
#define POSTLER_STOCK_ARCHIVE "gnome-mime-application-x-archive"
gchar* postler_folder_type_get_label (PostlerFolderType self);
static gchar** _vala_array_dup1 (gchar** self, int length);
#define POSTLER_hide_folder_default "Apple Mail To Do"
GType postler_account_info_get_type (void) G_GNUC_CONST;
enum  {
	POSTLER_ACCOUNT_INFO_DUMMY_PROPERTY
};
const gchar* postler_account_info_get_folder (PostlerAccountInfo* self, PostlerFolderType type);
gboolean postler_account_info_can_delete (PostlerAccountInfo* self);
void postler_account_info_set_folder (PostlerAccountInfo* self, PostlerFolderType type, const gchar* folder);
void postler_account_info_get_localized_folder (PostlerAccountInfo* self, const gchar* folder_name, PostlerMailFolder* result);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
void postler_account_info_verify_folders (PostlerAccountInfo* self, PostlerAccountInfoMailFolderCallback callback, void* callback_target);
PostlerAccountInfo* postler_account_info_new (void);
PostlerAccountInfo* postler_account_info_construct (GType object_type);
static void postler_account_info_finalize (GObject* obj);
GType postler_accounts_get_type (void) G_GNUC_CONST;
#define POSTLER_ACCOUNTS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POSTLER_TYPE_ACCOUNTS, PostlerAccountsPrivate))
enum  {
	POSTLER_ACCOUNTS_DUMMY_PROPERTY
};
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
PostlerAccounts* postler_accounts_new (void);
PostlerAccounts* postler_accounts_construct (GType object_type);
static void postler_accounts_reload (PostlerAccounts* self);
static void postler_accounts_update_display_names (PostlerAccounts* self);
static void postler_accounts_write_keyfile (PostlerAccounts* self, GError** error);
void postler_accounts_update (PostlerAccounts* self);
static gboolean postler_accounts_remove_path (PostlerAccounts* self, const gchar* path, GError** error);
static void postler_accounts_delete_account (PostlerAccounts* self, PostlerAccountInfo* info);
gchar** postler_accounts_get_folders (PostlerAccounts* self, int* result_length1);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
GList* postler_accounts_get_infos (PostlerAccounts* self);
static gchar* postler_accounts_get_tool_configfile (PostlerAccounts* self, const gchar* send, PostlerAccountInfo* info, GError** error);
static gchar* postler_accounts_get_tool_configuration (PostlerAccounts* self, const gchar* send, PostlerAccountInfo* info, GError** error);
gchar* postler_accounts_get_receive_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error);
gchar* postler_accounts_get_fetch_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error);
gchar* postler_accounts_get_send_command (PostlerAccounts* self, PostlerAccountInfo* info, const gchar* send, GError** error);
static void postler_accounts_real_add_info (PostlerAccounts* self, PostlerAccountInfo* info);
static void postler_accounts_real_remove_info (PostlerAccounts* self, PostlerAccountInfo* info);
static void postler_accounts_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

const gchar* POSTLER_sent_folders[3] = {"[Gmail]~-Sent Mail", "[Gmail]~-Gesendet", "Gesendet"};
const gchar* POSTLER_drafts_folders[3] = {"[Gmail]~-Drafts", "[Gmail]~-Entw&APw-rfe", "Entwurf"};
const gchar* POSTLER_queue_folders[1] = {"Postausgang"};
const gchar* POSTLER_trash_folders[3] = {"[Gmail]~-Trash", "[Gmail]~-Papierkorb", "Papierkorb"};
const gchar* POSTLER_archive_folders[2] = {"[Gmail]~-All Mail", "[Gmail]~-Alle Nachrichten"};
const gchar* POSTLER_junk_folders[1] = {"[Gmail]~-Spam"};
const PostlerMailFolder POSTLER_localized_folders[8] = {{"INBOX", POSTLER_STOCK_INBOX, "Inbox", NULL, 0, 0, POSTLER_FOLDER_TYPE_INBOX, 0}, {"Sent", POSTLER_STOCK_SENT_MAIL, "Sent", POSTLER_sent_folders, G_N_ELEMENTS (POSTLER_sent_folders), G_N_ELEMENTS (POSTLER_sent_folders), POSTLER_FOLDER_TYPE_SENT, 1}, {"Drafts", NULL, "Drafts", POSTLER_drafts_folders, G_N_ELEMENTS (POSTLER_drafts_folders), G_N_ELEMENTS (POSTLER_drafts_folders), POSTLER_FOLDER_TYPE_DRAFTS, 2}, {"Queue", POSTLER_STOCK_OUTBOX, "Outbox", POSTLER_queue_folders, G_N_ELEMENTS (POSTLER_queue_folders), G_N_ELEMENTS (POSTLER_queue_folders), POSTLER_FOLDER_TYPE_QUEUE, 3}, {"Trash", POSTLER_STOCK_USER_TRASH, "Trash", POSTLER_trash_folders, G_N_ELEMENTS (POSTLER_trash_folders), G_N_ELEMENTS (POSTLER_trash_folders), POSTLER_FOLDER_TYPE_TRASH, 4}, {"Archive", POSTLER_STOCK_ARCHIVE, "Archive", POSTLER_archive_folders, G_N_ELEMENTS (POSTLER_archive_folders), G_N_ELEMENTS (POSTLER_archive_folders), POSTLER_FOLDER_TYPE_ARCHIVE, 5}, {NULL, NULL, "Junk", POSTLER_junk_folders, G_N_ELEMENTS (POSTLER_junk_folders), G_N_ELEMENTS (POSTLER_junk_folders), POSTLER_FOLDER_TYPE_JUNK, 6}, {NULL, GTK_STOCK_DIRECTORY, NULL, NULL, 0, 0, POSTLER_FOLDER_TYPE_GENERIC, 7}};
static const gchar* POSTLER_ACCOUNTS_root_certificate_files[4] = {"/etc/pki/tls/certs/ca-bundle.crt", "/etc/ssl/certs/ca-certificates.crt", "/etc/ssl/certs/ca-bundle.crt", "/usr/local/share/certs/ca-root-nss.crt"};

GType postler_account_type_get_type (void) {
	static volatile gsize postler_account_type_type_id__volatile = 0;
	if (g_once_init_enter (&postler_account_type_type_id__volatile)) {
		static const GEnumValue values[] = {{POSTLER_ACCOUNT_TYPE_MAILDIR, "POSTLER_ACCOUNT_TYPE_MAILDIR", "maildir"}, {POSTLER_ACCOUNT_TYPE_IMAP, "POSTLER_ACCOUNT_TYPE_IMAP", "imap"}, {POSTLER_ACCOUNT_TYPE_SEARCH, "POSTLER_ACCOUNT_TYPE_SEARCH", "search"}, {0, NULL, NULL}};
		GType postler_account_type_type_id;
		postler_account_type_type_id = g_enum_register_static ("PostlerAccountType", values);
		g_once_init_leave (&postler_account_type_type_id__volatile, postler_account_type_type_id);
	}
	return postler_account_type_type_id__volatile;
}


gchar* postler_folder_type_get_stock_id (PostlerFolderType self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup (POSTLER_localized_folders[self].stock_id);
	result = _tmp0_;
	return result;
}


gchar* postler_folder_type_get_label (PostlerFolderType self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	_tmp0_ = _ (POSTLER_localized_folders[self].label);
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


GType postler_folder_type_get_type (void) {
	static volatile gsize postler_folder_type_type_id__volatile = 0;
	if (g_once_init_enter (&postler_folder_type_type_id__volatile)) {
		static const GEnumValue values[] = {{POSTLER_FOLDER_TYPE_INBOX, "POSTLER_FOLDER_TYPE_INBOX", "inbox"}, {POSTLER_FOLDER_TYPE_SENT, "POSTLER_FOLDER_TYPE_SENT", "sent"}, {POSTLER_FOLDER_TYPE_DRAFTS, "POSTLER_FOLDER_TYPE_DRAFTS", "drafts"}, {POSTLER_FOLDER_TYPE_QUEUE, "POSTLER_FOLDER_TYPE_QUEUE", "queue"}, {POSTLER_FOLDER_TYPE_TRASH, "POSTLER_FOLDER_TYPE_TRASH", "trash"}, {POSTLER_FOLDER_TYPE_ARCHIVE, "POSTLER_FOLDER_TYPE_ARCHIVE", "archive"}, {POSTLER_FOLDER_TYPE_JUNK, "POSTLER_FOLDER_TYPE_JUNK", "junk"}, {POSTLER_FOLDER_TYPE_GENERIC, "POSTLER_FOLDER_TYPE_GENERIC", "generic"}, {POSTLER_FOLDER_TYPE_MAX, "POSTLER_FOLDER_TYPE_MAX", "max"}, {0, NULL, NULL}};
		GType postler_folder_type_type_id;
		postler_folder_type_type_id = g_enum_register_static ("PostlerFolderType", values);
		g_once_init_leave (&postler_folder_type_type_id__volatile, postler_folder_type_type_id);
	}
	return postler_folder_type_type_id__volatile;
}


static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


void postler_mail_folder_copy (const PostlerMailFolder* self, PostlerMailFolder* dest) {
	gchar** _tmp0_;
	_g_free0 ((*dest).role);
	(*dest).role = g_strdup ((*self).role);
	_g_free0 ((*dest).stock_id);
	(*dest).stock_id = g_strdup ((*self).stock_id);
	_g_free0 ((*dest).label);
	(*dest).label = g_strdup ((*self).label);
	(*dest).localized = (_vala_array_free ((*dest).localized, (*dest).localized_length1, (GDestroyNotify) g_free), NULL);
	(*dest).localized = (_tmp0_ = (*self).localized, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup1 (_tmp0_, (*self).localized_length1));
	(*dest).localized_length1 = (*self).localized_length1;
	(*dest).n_localized = (*self).n_localized;
	(*dest).type = (*self).type;
	(*dest).i_type = (*self).i_type;
}


void postler_mail_folder_destroy (PostlerMailFolder* self) {
	_g_free0 ((*self).role);
	_g_free0 ((*self).stock_id);
	_g_free0 ((*self).label);
	(*self).localized = (_vala_array_free ((*self).localized, (*self).localized_length1, (GDestroyNotify) g_free), NULL);
}


PostlerMailFolder* postler_mail_folder_dup (const PostlerMailFolder* self) {
	PostlerMailFolder* dup;
	dup = g_new0 (PostlerMailFolder, 1);
	postler_mail_folder_copy (self, dup);
	return dup;
}


void postler_mail_folder_free (PostlerMailFolder* self) {
	postler_mail_folder_destroy (self);
	g_free (self);
}


GType postler_mail_folder_get_type (void) {
	static volatile gsize postler_mail_folder_type_id__volatile = 0;
	if (g_once_init_enter (&postler_mail_folder_type_id__volatile)) {
		GType postler_mail_folder_type_id;
		postler_mail_folder_type_id = g_boxed_type_register_static ("PostlerMailFolder", (GBoxedCopyFunc) postler_mail_folder_dup, (GBoxedFreeFunc) postler_mail_folder_free);
		g_once_init_leave (&postler_mail_folder_type_id__volatile, postler_mail_folder_type_id);
	}
	return postler_mail_folder_type_id__volatile;
}


const gchar* postler_account_info_get_folder (PostlerAccountInfo* self, PostlerFolderType type) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->folders[type];
	return result;
}


gboolean postler_account_info_can_delete (PostlerAccountInfo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->type == POSTLER_ACCOUNT_TYPE_SEARCH) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->folders[POSTLER_FOLDER_TYPE_TRASH] != NULL;
	}
	result = _tmp0_;
	return result;
}


void postler_account_info_set_folder (PostlerAccountInfo* self, PostlerFolderType type, const gchar* folder) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (folder != NULL);
	_tmp0_ = g_strdup (folder);
	_tmp1_ = _tmp0_;
	_g_free0 (self->folders[type]);
	self->folders[type] = _tmp1_;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_;
		GRegex* regex;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		_tmp0_ = g_regex_escape_string (old, -1);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
		_tmp3_ = _tmp2_;
		_g_free0 (_tmp1_);
		regex = _tmp3_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch10_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp4_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
		_tmp5_ = _tmp4_;
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch10_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp5_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally10;
	__catch10_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally10:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


void postler_account_info_get_localized_folder (PostlerAccountInfo* self, const gchar* folder_name, PostlerMailFolder* result) {
	gchar* _tmp1_ = NULL;
	gchar* sane_name;
	g_return_if_fail (self != NULL);
	g_return_if_fail (folder_name != NULL);
	{
		gint type;
		type = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					type++;
				}
				_tmp0_ = FALSE;
				if (!(type < ((gint) POSTLER_FOLDER_TYPE_MAX))) {
					break;
				}
				if (g_strcmp0 (self->folders[type], folder_name) == 0) {
					*result = POSTLER_localized_folders[type];
					return;
				}
			}
		}
	}
	_tmp1_ = string_replace (folder_name, "[Google Mail]", "[Gmail]");
	sane_name = _tmp1_;
	{
		gint type;
		type = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				if (!_tmp2_) {
					type++;
				}
				_tmp2_ = FALSE;
				if (!(type < ((gint) POSTLER_FOLDER_TYPE_MAX))) {
					break;
				}
				if (self->folders[type] == NULL) {
					_tmp4_ = POSTLER_localized_folders[type].localized != NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					_tmp3_ = _vala_string_array_contains (POSTLER_localized_folders[type].localized, POSTLER_localized_folders[type].localized_length1, sane_name);
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					gchar* _tmp5_;
					gchar* _tmp6_;
					const gchar* role;
					gboolean _tmp7_ = FALSE;
					_tmp5_ = g_strdup (folder_name);
					_tmp6_ = _tmp5_;
					_g_free0 (self->folders[type]);
					self->folders[type] = _tmp6_;
					role = POSTLER_localized_folders[type].role;
					if (role != NULL) {
						gboolean _tmp8_;
						_tmp8_ = string_contains (self->hide, role);
						_tmp7_ = !_tmp8_;
					} else {
						_tmp7_ = FALSE;
					}
					if (_tmp7_) {
						gchar* _tmp9_;
						gchar* _tmp10_;
						gchar* _tmp11_;
						_tmp9_ = g_strconcat (",", role, NULL);
						_tmp10_ = _tmp9_;
						_tmp11_ = g_strconcat (self->hide, _tmp10_, NULL);
						_g_free0 (self->hide);
						self->hide = _tmp11_;
						_g_free0 (_tmp10_);
					}
					*result = POSTLER_localized_folders[type];
					_g_free0 (sane_name);
					return;
				}
			}
		}
	}
	*result = POSTLER_localized_folders[POSTLER_FOLDER_TYPE_GENERIC];
	_g_free0 (sane_name);
	return;
}


void postler_account_info_verify_folders (PostlerAccountInfo* self, PostlerAccountInfoMailFolderCallback callback, void* callback_target) {
	g_return_if_fail (self != NULL);
	{
		gint type;
		type = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp1_ = FALSE;
				if (!_tmp0_) {
					type++;
				}
				_tmp0_ = FALSE;
				if (!(type < ((gint) POSTLER_FOLDER_TYPE_MAX))) {
					break;
				}
				if (self->folders[type] == NULL) {
					_tmp1_ = POSTLER_localized_folders[type].role != NULL;
				} else {
					_tmp1_ = FALSE;
				}
				if (_tmp1_) {
					if (type != ((gint) POSTLER_FOLDER_TYPE_GENERIC)) {
						PostlerMailFolder _tmp2_;
						_tmp2_ = POSTLER_localized_folders[type];
						callback (type, &_tmp2_, callback_target);
					}
				}
			}
		}
	}
}


PostlerAccountInfo* postler_account_info_construct (GType object_type) {
	PostlerAccountInfo * self = NULL;
	self = (PostlerAccountInfo*) g_object_new (object_type, NULL);
	return self;
}


PostlerAccountInfo* postler_account_info_new (void) {
	return postler_account_info_construct (POSTLER_TYPE_ACCOUNT_INFO);
}


static void postler_account_info_class_init (PostlerAccountInfoClass * klass) {
	postler_account_info_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = postler_account_info_finalize;
}


static void postler_account_info_instance_init (PostlerAccountInfo * self) {
	gchar* _tmp0_;
	gchar** _tmp1_ = NULL;
	_tmp0_ = g_strdup (POSTLER_hide_folder_default);
	self->hide = _tmp0_;
	_tmp1_ = g_new0 (gchar*, 8 + 1);
	_tmp1_[0] = NULL;
	_tmp1_[1] = NULL;
	_tmp1_[2] = NULL;
	_tmp1_[3] = NULL;
	_tmp1_[4] = NULL;
	_tmp1_[5] = NULL;
	_tmp1_[6] = NULL;
	_tmp1_[7] = NULL;
	self->folders = _tmp1_;
	self->folders_length1 = 8;
}


static void postler_account_info_finalize (GObject* obj) {
	PostlerAccountInfo * self;
	self = POSTLER_ACCOUNT_INFO (obj);
	_g_free0 (self->name);
	_g_free0 (self->display_name);
	_g_free0 (self->realname);
	_g_free0 (self->address);
	_g_free0 (self->receive);
	_g_free0 (self->send);
	_g_free0 (self->username);
	_g_free0 (self->password);
	_g_free0 (self->prefix);
	_g_free0 (self->path);
	_g_free0 (self->certificate);
	_g_free0 (self->reply);
	_g_free0 (self->organization);
	_g_free0 (self->signature);
	_g_free0 (self->hide);
	self->folders = (_vala_array_free (self->folders, self->folders_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (postler_account_info_parent_class)->finalize (obj);
}


GType postler_account_info_get_type (void) {
	static volatile gsize postler_account_info_type_id__volatile = 0;
	if (g_once_init_enter (&postler_account_info_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PostlerAccountInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) postler_account_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PostlerAccountInfo), 0, (GInstanceInitFunc) postler_account_info_instance_init, NULL };
		GType postler_account_info_type_id;
		postler_account_info_type_id = g_type_register_static (G_TYPE_OBJECT, "PostlerAccountInfo", &g_define_type_info, 0);
		g_once_init_leave (&postler_account_info_type_id__volatile, postler_account_info_type_id);
	}
	return postler_account_info_type_id__volatile;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


PostlerAccounts* postler_accounts_construct (GType object_type) {
	PostlerAccounts * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* config_dir;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* data_dir;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	self = (PostlerAccounts*) g_object_new (object_type, NULL);
	_tmp0_ = g_get_user_config_dir ();
	config_dir = _tmp0_;
	_tmp1_ = g_strconcat (config_dir, "/", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, PACKAGE_NAME, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, "/", NULL);
	_g_free0 (self->priv->config_path);
	self->priv->config_path = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp6_ = g_strconcat (self->priv->config_path, "accountrc", NULL);
	_g_free0 (self->priv->account_file);
	self->priv->account_file = _tmp6_;
	_tmp7_ = g_get_user_data_dir ();
	data_dir = _tmp7_;
	_tmp8_ = g_strconcat (data_dir, "/", NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat (_tmp9_, PACKAGE_NAME, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "/mail/", NULL);
	_g_free0 (self->priv->data_path);
	self->priv->data_path = _tmp12_;
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	{
		const gchar** file_collection = NULL;
		gint file_collection_length1 = 0;
		gint _file_collection_size_ = 0;
		gint file_it;
		file_collection = POSTLER_ACCOUNTS_root_certificate_files;
		file_collection_length1 = G_N_ELEMENTS (POSTLER_ACCOUNTS_root_certificate_files);
		for (file_it = 0; file_it < G_N_ELEMENTS (POSTLER_ACCOUNTS_root_certificate_files); file_it = file_it + 1) {
			const gchar* file = NULL;
			file = file_collection[file_it];
			{
				gboolean _tmp13_;
				_tmp13_ = g_file_test (file, G_FILE_TEST_EXISTS);
				if (_tmp13_) {
					gchar* _tmp14_;
					_tmp14_ = g_strdup (file);
					_g_free0 (self->priv->certificate_file);
					self->priv->certificate_file = _tmp14_;
				}
			}
		}
	}
	if (self->priv->certificate_file == NULL) {
		const gchar* _tmp15_ = NULL;
		_tmp15_ = _ ("Failed to find a root certificate file.");
		g_warning ("postler-accounts.vala:173: %s", _tmp15_);
	}
	postler_accounts_reload (self);
	return self;
}


PostlerAccounts* postler_accounts_new (void) {
	return postler_accounts_construct (POSTLER_TYPE_ACCOUNTS);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void postler_accounts_update_display_names (PostlerAccounts* self) {
	guint num_accounts;
	g_return_if_fail (self != NULL);
	num_accounts = (guint) 0;
	{
		GList* info_collection = NULL;
		GList* info_it = NULL;
		info_collection = self->priv->infos;
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
			PostlerAccountInfo* _tmp0_;
			PostlerAccountInfo* info = NULL;
			_tmp0_ = _g_object_ref0 ((PostlerAccountInfo*) info_it->data);
			info = _tmp0_;
			{
				gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp4_ = NULL;
				gchar* _tmp5_;
				gchar* domain;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp22_;
				if (info->type != POSTLER_ACCOUNT_TYPE_SEARCH) {
					num_accounts++;
				}
				_tmp1_ = g_strdup (info->address);
				_tmp2_ = _tmp1_;
				if (_tmp2_ == NULL) {
					gchar* _tmp3_;
					_tmp3_ = g_strdup (info->name);
					_g_free0 (_tmp2_);
					_tmp2_ = _tmp3_;
				}
				_tmp4_ = g_strrstr (_tmp2_, "@");
				_tmp5_ = g_strdup (_tmp4_);
				domain = _tmp5_;
				if (domain != NULL) {
					const gchar* _tmp12_ = NULL;
					gchar* _tmp14_;
					{
						GList* account_info_collection = NULL;
						GList* account_info_it = NULL;
						account_info_collection = self->priv->infos;
						for (account_info_it = account_info_collection; account_info_it != NULL; account_info_it = account_info_it->next) {
							PostlerAccountInfo* _tmp6_;
							PostlerAccountInfo* account_info = NULL;
							_tmp6_ = _g_object_ref0 ((PostlerAccountInfo*) account_info_it->data);
							account_info = _tmp6_;
							{
								gchar* _tmp7_;
								gchar* _tmp8_;
								const gchar* address;
								gboolean _tmp10_ = FALSE;
								_tmp7_ = g_strdup (account_info->address);
								_tmp8_ = _tmp7_;
								if (_tmp8_ == NULL) {
									gchar* _tmp9_;
									_tmp9_ = g_strdup (account_info->name);
									_g_free0 (_tmp8_);
									_tmp8_ = _tmp9_;
								}
								address = _tmp8_;
								if (account_info != info) {
									gboolean _tmp11_;
									_tmp11_ = string_contains (address, domain);
									_tmp10_ = _tmp11_;
								} else {
									_tmp10_ = FALSE;
								}
								if (_tmp10_) {
									_g_free0 (domain);
									domain = NULL;
									_g_free0 (_tmp8_);
									_g_object_unref0 (account_info);
									break;
								}
								_g_free0 (_tmp8_);
								_g_object_unref0 (account_info);
							}
						}
					}
					if (domain != NULL) {
						const gchar* _tmp13_ = NULL;
						_tmp13_ = g_utf8_next_char (domain);
						_tmp12_ = _tmp13_;
					} else {
						_tmp12_ = NULL;
					}
					_tmp14_ = g_strdup (_tmp12_);
					_g_free0 (domain);
					domain = _tmp14_;
					if (domain != NULL) {
						gchar** _tmp15_;
						gchar** _tmp16_ = NULL;
						gchar** _tmp17_;
						gint _tmp17__length1;
						gchar* _tmp18_;
						_tmp16_ = _tmp15_ = g_strsplit (domain, ".", 2);
						_tmp17_ = _tmp16_;
						_tmp17__length1 = _vala_array_length (_tmp15_);
						_tmp18_ = g_strdup (_tmp17_[0]);
						_g_free0 (domain);
						domain = _tmp18_;
						_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
					}
				}
				_tmp19_ = g_strdup (domain);
				_tmp20_ = _tmp19_;
				if (_tmp20_ == NULL) {
					gchar* _tmp21_;
					_tmp21_ = g_strdup (info->name);
					_g_free0 (_tmp20_);
					_tmp20_ = _tmp21_;
				}
				_tmp22_ = g_strdup (_tmp20_);
				_g_free0 (info->display_name);
				info->display_name = _tmp22_;
				_g_free0 (_tmp20_);
				_g_free0 (domain);
				_g_free0 (_tmp2_);
				_g_object_unref0 (info);
			}
		}
	}
	if (num_accounts == ((guint) 1)) {
		{
			GList* info_collection = NULL;
			GList* info_it = NULL;
			info_collection = self->priv->infos;
			for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
				PostlerAccountInfo* _tmp23_;
				PostlerAccountInfo* info = NULL;
				_tmp23_ = _g_object_ref0 ((PostlerAccountInfo*) info_it->data);
				info = _tmp23_;
				{
					if (info->type != POSTLER_ACCOUNT_TYPE_SEARCH) {
						const gchar* _tmp24_ = NULL;
						gchar* _tmp25_;
						_tmp24_ = _ ("Inbox");
						_tmp25_ = g_strdup (_tmp24_);
						_g_free0 (info->display_name);
						info->display_name = _tmp25_;
					}
					_g_object_unref0 (info);
				}
			}
		}
	}
}


static void postler_accounts_write_keyfile (PostlerAccounts* self, GError** error) {
	gint _tmp0_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	const gchar* config_dir;
	const gchar* indicator_dir;
	gchar* _tmp6_;
	gchar* indicator_path;
	gchar* _tmp7_;
	gchar* filename;
	gboolean _tmp8_;
	gboolean exists;
	gboolean _tmp9_ = FALSE;
	guint _tmp10_;
	gchar* _tmp12_;
	gchar* autostart_path;
	gchar* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_ = FALSE;
	guint _tmp16_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_mkdir_with_parents (self->priv->config_path, 0700);
	if (_tmp0_ != 0) {
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		_tmp1_ = _ ("Config folder couldn't be created.");
		_tmp2_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp1_);
		_inner_error_ = _tmp2_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = g_key_file_to_data (self->priv->keyfile, NULL, NULL);
	_tmp4_ = _tmp3_;
	g_file_set_contents (self->priv->account_file, _tmp4_, (gssize) (-1), &_inner_error_);
	_g_free0 (_tmp4_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp5_ = g_get_user_config_dir ();
	config_dir = _tmp5_;
	indicator_dir = "/indicators/messages/applications";
	_tmp6_ = g_strconcat (config_dir, indicator_dir, NULL);
	indicator_path = _tmp6_;
	_tmp7_ = g_strconcat (indicator_path, "/postler.desktop", NULL);
	filename = _tmp7_;
	_tmp8_ = g_file_test (filename, G_FILE_TEST_EXISTS);
	exists = _tmp8_;
	_tmp10_ = g_list_length (self->priv->infos);
	if (_tmp10_ != ((guint) 0)) {
		_tmp9_ = !exists;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		g_mkdir_with_parents (indicator_path, 0700);
		g_file_set_contents (filename, MDATADIR "/applications/postler.desktop", (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (filename);
			_g_free0 (indicator_path);
			return;
		}
	} else {
		guint _tmp11_;
		_tmp11_ = g_list_length (self->priv->infos);
		if (_tmp11_ == ((guint) 0)) {
			g_unlink (filename);
		}
	}
	_tmp12_ = g_strconcat (config_dir, "/autostart", NULL);
	autostart_path = _tmp12_;
	_tmp13_ = g_strconcat (autostart_path, "/postler.desktop", NULL);
	_g_free0 (filename);
	filename = _tmp13_;
	_tmp14_ = g_file_test (filename, G_FILE_TEST_EXISTS);
	exists = _tmp14_;
	_tmp16_ = g_list_length (self->priv->infos);
	if (_tmp16_ != ((guint) 0)) {
		_tmp15_ = !exists;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		g_mkdir_with_parents (autostart_path, 0700);
		g_file_set_contents (filename, "[Desktop Entry]\nVersion=1.0\nType=Application\nName=Postler\n" "Exec=postler -m service\nIcon=postler", (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (autostart_path);
			_g_free0 (filename);
			_g_free0 (indicator_path);
			return;
		}
	} else {
		guint _tmp17_;
		_tmp17_ = g_list_length (self->priv->infos);
		if (_tmp17_ == ((guint) 0)) {
			g_unlink (filename);
		}
	}
	postler_accounts_update_display_names (self);
	_g_free0 (autostart_path);
	_g_free0 (filename);
	_g_free0 (indicator_path);
}


void postler_accounts_update (PostlerAccounts* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		{
			GList* account_info_collection = NULL;
			GList* account_info_it = NULL;
			account_info_collection = self->priv->infos;
			for (account_info_it = account_info_collection; account_info_it != NULL; account_info_it = account_info_it->next) {
				PostlerAccountInfo* _tmp0_;
				PostlerAccountInfo* account_info = NULL;
				_tmp0_ = _g_object_ref0 ((PostlerAccountInfo*) account_info_it->data);
				account_info = _tmp0_;
				{
					gchar* _tmp1_;
					gchar* group;
					_tmp1_ = g_strdup (account_info->name);
					group = _tmp1_;
					g_return_if_fail (group != NULL);
					if (account_info->type == POSTLER_ACCOUNT_TYPE_MAILDIR) {
						gboolean _tmp2_ = FALSE;
						gboolean _tmp4_ = FALSE;
						g_key_file_set_string (self->priv->keyfile, group, "type", "maildir");
						if (account_info->path != NULL) {
							gboolean _tmp3_;
							_tmp3_ = string_contains (account_info->path, self->priv->data_path);
							_tmp2_ = !_tmp3_;
						} else {
							_tmp2_ = FALSE;
						}
						if (_tmp2_) {
							g_key_file_set_string (self->priv->keyfile, group, "path", account_info->path);
						}
						if (account_info->hide != NULL) {
							_tmp4_ = g_strcmp0 (account_info->hide, POSTLER_hide_folder_default) != 0;
						} else {
							_tmp4_ = FALSE;
						}
						if (_tmp4_) {
							g_key_file_set_string (self->priv->keyfile, group, "hide", account_info->hide);
						}
					} else {
						if (account_info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
							gboolean _tmp5_ = FALSE;
							g_key_file_set_string (self->priv->keyfile, group, "type", "imap");
							if (account_info->realname != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "realname", account_info->realname);
							}
							if (account_info->address != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "address", account_info->address);
							}
							if (account_info->username != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "username", account_info->username);
							}
							if (account_info->password != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "password", account_info->password);
							}
							if (account_info->prefix != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "prefix", account_info->prefix);
							}
							if (account_info->receive != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "receive", account_info->receive);
							}
							if (account_info->send != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "send", account_info->send);
							}
							if (account_info->send_port != 0) {
								g_key_file_set_integer (self->priv->keyfile, group, "send-port", account_info->send_port);
							}
							if (account_info->certificate != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "certificate", account_info->certificate);
							}
							if (account_info->unverified) {
								g_key_file_set_boolean (self->priv->keyfile, group, "unverified", TRUE);
							}
							if (account_info->reply != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "reply", account_info->reply);
							}
							if (account_info->organization != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "organization", account_info->organization);
							}
							if (account_info->signature != NULL) {
								g_key_file_set_string (self->priv->keyfile, group, "signature", account_info->signature);
							}
							if (account_info->hide != NULL) {
								_tmp5_ = g_strcmp0 (account_info->hide, POSTLER_hide_folder_default) != 0;
							} else {
								_tmp5_ = FALSE;
							}
							if (_tmp5_) {
								g_key_file_set_string (self->priv->keyfile, group, "hide", account_info->hide);
							}
							{
								gint type;
								type = 0;
								{
									gboolean _tmp6_;
									_tmp6_ = TRUE;
									while (TRUE) {
										if (!_tmp6_) {
											type++;
										}
										_tmp6_ = FALSE;
										if (!(type < ((gint) POSTLER_FOLDER_TYPE_MAX))) {
											break;
										}
										if (account_info->folders[type] != NULL) {
											gchar* _tmp7_ = NULL;
											gchar* _tmp8_;
											gchar* _tmp9_;
											gchar* _tmp10_;
											_tmp7_ = g_strdup_printf ("%i", type);
											_tmp8_ = _tmp7_;
											_tmp9_ = g_strconcat ("localized", _tmp8_, NULL);
											_tmp10_ = _tmp9_;
											g_key_file_set_string (self->priv->keyfile, group, _tmp10_, account_info->folders[type]);
											_g_free0 (_tmp10_);
											_g_free0 (_tmp8_);
										}
									}
								}
							}
						} else {
							if (account_info->type == POSTLER_ACCOUNT_TYPE_SEARCH) {
								g_key_file_set_string (self->priv->keyfile, group, "type", "search");
								g_key_file_set_string (self->priv->keyfile, group, "path", account_info->path);
							} else {
								g_assert_not_reached ();
							}
						}
					}
					_g_free0 (group);
					_g_object_unref0 (account_info);
				}
			}
		}
		postler_accounts_write_keyfile (self, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch11_g_error;
		}
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		g_critical ("postler-accounts.vala:305: Failed to save \"%s\": %s", self->priv->account_file, _error_->message);
		_g_error_free0 (_error_);
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gboolean postler_accounts_remove_path (PostlerAccounts* self, const gchar* path, GError** error) {
	gboolean result = FALSE;
	GDir* dir = NULL;
	gchar* name = NULL;
	gint _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	{
		GDir* _tmp0_ = NULL;
		GDir* _tmp1_;
		_tmp0_ = g_dir_open (path, (guint) 0, &_inner_error_);
		_tmp1_ = _tmp0_;
		if (_inner_error_ != NULL) {
			goto __catch12_g_error;
		}
		_g_dir_close0 (dir);
		dir = _tmp1_;
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* _error_ = NULL;
		gint _tmp2_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = g_remove (path);
		result = _tmp2_ == 0;
		_g_error_free0 (_error_);
		_g_dir_close0 (dir);
		return result;
	}
	__finally12:
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_dir_close0 (dir);
			return FALSE;
		} else {
			_g_dir_close0 (dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	while (TRUE) {
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* subpath;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp3_ = g_dir_read_name (dir);
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (name);
		name = _tmp4_;
		if (!(name != NULL)) {
			break;
		}
		_tmp5_ = g_build_filename (path, name, NULL);
		subpath = _tmp5_;
		_tmp6_ = postler_accounts_remove_path (self, subpath, &_inner_error_);
		_tmp7_ = _tmp6_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (subpath);
				_g_free0 (name);
				_g_dir_close0 (dir);
				return FALSE;
			} else {
				_g_free0 (subpath);
				_g_free0 (name);
				_g_dir_close0 (dir);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
		}
		if (!_tmp7_) {
			result = FALSE;
			_g_free0 (subpath);
			_g_free0 (name);
			_g_dir_close0 (dir);
			return result;
		}
		_g_free0 (subpath);
	}
	_tmp8_ = g_remove (path);
	result = _tmp8_ == 0;
	_g_free0 (name);
	_g_dir_close0 (dir);
	return result;
}


static void postler_accounts_delete_account (PostlerAccounts* self, PostlerAccountInfo* info) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	g_return_if_fail (info->name != NULL);
	{
		if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
			gboolean _tmp0_;
			gboolean _tmp1_;
			_tmp0_ = postler_accounts_remove_path (self, info->path, &_inner_error_);
			_tmp1_ = _tmp0_;
			if (_inner_error_ != NULL) {
				goto __catch13_g_error;
			}
			if (!_tmp1_) {
				const gchar* _tmp2_ = NULL;
				gchar* _tmp3_ = NULL;
				gchar* _tmp4_;
				GError* _tmp5_ = NULL;
				GError* _tmp6_;
				_tmp2_ = _ ("Failed to remove \"%s\"");
				_tmp3_ = g_strdup_printf (_tmp2_, info->path);
				_tmp4_ = _tmp3_;
				_tmp5_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp4_);
				_tmp6_ = _tmp5_;
				_g_free0 (_tmp4_);
				_inner_error_ = _tmp6_;
				goto __catch13_g_error;
			}
		}
		g_key_file_remove_group (self->priv->keyfile, info->name, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch13_g_error;
		}
		postler_accounts_write_keyfile (self, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch13_g_error;
		}
	}
	goto __finally13;
	__catch13_g_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		g_critical ("postler-accounts.vala:338: Failed to save \"%s\": %s", self->priv->account_file, _error_->message);
		_g_error_free0 (_error_);
	}
	__finally13:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void postler_accounts_reload (PostlerAccounts* self) {
	GKeyFile* _tmp0_ = NULL;
	gsize _tmp1_;
	gchar** _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	__g_list_free__g_object_unref0_0 (self->priv->infos);
	self->priv->infos = NULL;
	_tmp0_ = g_key_file_new ();
	_g_key_file_free0 (self->priv->keyfile);
	self->priv->keyfile = _tmp0_;
	{
		g_key_file_load_from_file (self->priv->keyfile, self->priv->account_file, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch14_g_error;
		}
	}
	goto __finally14;
	__catch14_g_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		g_debug ("postler-accounts.vala:349: Failed to load \"%s\": %s", self->priv->account_file, _error_->message);
		_g_error_free0 (_error_);
	}
	__finally14:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp2_ = g_key_file_get_groups (self->priv->keyfile, &_tmp1_);
	{
		gchar** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it;
		group_collection = _tmp2_;
		group_collection_length1 = _tmp1_;
		for (group_it = 0; group_it < _tmp1_; group_it = group_it + 1) {
			gchar* _tmp3_;
			gchar* group = NULL;
			_tmp3_ = g_strdup (group_collection[group_it]);
			group = _tmp3_;
			{
				{
					gchar* _tmp4_ = NULL;
					gchar* type;
					PostlerAccountInfo* _tmp5_ = NULL;
					PostlerAccountInfo* info;
					gchar* _tmp6_;
					PostlerAccountInfo* _tmp90_;
					_tmp4_ = g_key_file_get_string (self->priv->keyfile, group, "type", &_inner_error_);
					type = _tmp4_;
					if (_inner_error_ != NULL) {
						goto __catch15_g_error;
					}
					_tmp5_ = postler_account_info_new ();
					info = _tmp5_;
					_tmp6_ = g_strdup (group);
					_g_free0 (info->name);
					info->name = _tmp6_;
					if (g_strcmp0 (type, "maildir") == 0) {
						gboolean _tmp7_;
						gboolean _tmp8_;
						gboolean _tmp12_;
						gboolean _tmp13_;
						info->type = POSTLER_ACCOUNT_TYPE_MAILDIR;
						_tmp7_ = g_key_file_has_key (self->priv->keyfile, group, "path", &_inner_error_);
						_tmp8_ = _tmp7_;
						if (_inner_error_ != NULL) {
							_g_object_unref0 (info);
							_g_free0 (type);
							goto __catch15_g_error;
						}
						if (_tmp8_) {
							gchar* _tmp9_ = NULL;
							gchar* _tmp10_;
							_tmp9_ = g_key_file_get_string (self->priv->keyfile, group, "path", &_inner_error_);
							_tmp10_ = _tmp9_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							_g_free0 (info->path);
							info->path = _tmp10_;
						} else {
							gchar* _tmp11_;
							_tmp11_ = g_strconcat (self->priv->data_path, info->name, NULL);
							_g_free0 (info->path);
							info->path = _tmp11_;
						}
						_tmp12_ = g_key_file_has_key (self->priv->keyfile, group, "hide", &_inner_error_);
						_tmp13_ = _tmp12_;
						if (_inner_error_ != NULL) {
							_g_object_unref0 (info);
							_g_free0 (type);
							goto __catch15_g_error;
						}
						if (_tmp13_) {
							gchar* _tmp14_ = NULL;
							gchar* _tmp15_;
							_tmp14_ = g_key_file_get_string (self->priv->keyfile, group, "hide", &_inner_error_);
							_tmp15_ = _tmp14_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							_g_free0 (info->hide);
							info->hide = _tmp15_;
						}
					} else {
						if (g_strcmp0 (type, "imap") == 0) {
							gchar* _tmp16_;
							gboolean _tmp17_;
							gboolean _tmp18_;
							gboolean _tmp21_;
							gboolean _tmp22_;
							gboolean _tmp25_;
							gboolean _tmp26_;
							gboolean _tmp29_;
							gboolean _tmp30_;
							gboolean _tmp33_;
							gboolean _tmp34_;
							gboolean _tmp37_;
							gboolean _tmp38_;
							gboolean _tmp41_;
							gboolean _tmp42_;
							gboolean _tmp45_;
							gboolean _tmp46_;
							gboolean _tmp49_;
							gboolean _tmp50_;
							gboolean _tmp53_;
							gboolean _tmp54_;
							gboolean _tmp57_;
							gboolean _tmp58_;
							gboolean _tmp61_;
							gboolean _tmp62_;
							gboolean _tmp65_;
							gboolean _tmp66_;
							gboolean _tmp69_;
							gboolean _tmp70_;
							info->type = POSTLER_ACCOUNT_TYPE_IMAP;
							_tmp16_ = g_strconcat (self->priv->data_path, info->name, NULL);
							_g_free0 (info->path);
							info->path = _tmp16_;
							_tmp17_ = g_key_file_has_key (self->priv->keyfile, group, "realname", &_inner_error_);
							_tmp18_ = _tmp17_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp18_) {
								gchar* _tmp19_ = NULL;
								gchar* _tmp20_;
								_tmp19_ = g_key_file_get_string (self->priv->keyfile, group, "realname", &_inner_error_);
								_tmp20_ = _tmp19_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->realname);
								info->realname = _tmp20_;
							}
							_tmp21_ = g_key_file_has_key (self->priv->keyfile, group, "address", &_inner_error_);
							_tmp22_ = _tmp21_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp22_) {
								gchar* _tmp23_ = NULL;
								gchar* _tmp24_;
								_tmp23_ = g_key_file_get_string (self->priv->keyfile, group, "address", &_inner_error_);
								_tmp24_ = _tmp23_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->address);
								info->address = _tmp24_;
							}
							_tmp25_ = g_key_file_has_key (self->priv->keyfile, group, "username", &_inner_error_);
							_tmp26_ = _tmp25_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp26_) {
								gchar* _tmp27_ = NULL;
								gchar* _tmp28_;
								_tmp27_ = g_key_file_get_string (self->priv->keyfile, group, "username", &_inner_error_);
								_tmp28_ = _tmp27_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->username);
								info->username = _tmp28_;
							}
							_tmp29_ = g_key_file_has_key (self->priv->keyfile, group, "password", &_inner_error_);
							_tmp30_ = _tmp29_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp30_) {
								gchar* _tmp31_ = NULL;
								gchar* _tmp32_;
								_tmp31_ = g_key_file_get_string (self->priv->keyfile, group, "password", &_inner_error_);
								_tmp32_ = _tmp31_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->password);
								info->password = _tmp32_;
							}
							_tmp33_ = g_key_file_has_key (self->priv->keyfile, group, "prefix", &_inner_error_);
							_tmp34_ = _tmp33_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp34_) {
								gchar* _tmp35_ = NULL;
								gchar* _tmp36_;
								_tmp35_ = g_key_file_get_string (self->priv->keyfile, group, "prefix", &_inner_error_);
								_tmp36_ = _tmp35_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->prefix);
								info->prefix = _tmp36_;
							}
							_tmp37_ = g_key_file_has_key (self->priv->keyfile, group, "receive", &_inner_error_);
							_tmp38_ = _tmp37_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp38_) {
								gchar* _tmp39_ = NULL;
								gchar* _tmp40_;
								_tmp39_ = g_key_file_get_string (self->priv->keyfile, group, "receive", &_inner_error_);
								_tmp40_ = _tmp39_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->receive);
								info->receive = _tmp40_;
							}
							_tmp41_ = g_key_file_has_key (self->priv->keyfile, group, "send", &_inner_error_);
							_tmp42_ = _tmp41_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp42_) {
								gchar* _tmp43_ = NULL;
								gchar* _tmp44_;
								_tmp43_ = g_key_file_get_string (self->priv->keyfile, group, "send", &_inner_error_);
								_tmp44_ = _tmp43_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->send);
								info->send = _tmp44_;
							}
							_tmp45_ = g_key_file_has_key (self->priv->keyfile, group, "send-port", &_inner_error_);
							_tmp46_ = _tmp45_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp46_) {
								gint _tmp47_;
								gint _tmp48_;
								_tmp47_ = g_key_file_get_integer (self->priv->keyfile, group, "send-port", &_inner_error_);
								_tmp48_ = _tmp47_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								info->send_port = _tmp48_;
							}
							_tmp49_ = g_key_file_has_key (self->priv->keyfile, group, "certificate", &_inner_error_);
							_tmp50_ = _tmp49_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp50_) {
								gchar* _tmp51_ = NULL;
								gchar* _tmp52_;
								_tmp51_ = g_key_file_get_string (self->priv->keyfile, group, "certificate", &_inner_error_);
								_tmp52_ = _tmp51_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->certificate);
								info->certificate = _tmp52_;
							}
							_tmp53_ = g_key_file_has_key (self->priv->keyfile, group, "unverified", &_inner_error_);
							_tmp54_ = _tmp53_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp54_) {
								gboolean _tmp55_;
								gboolean _tmp56_;
								_tmp55_ = g_key_file_get_boolean (self->priv->keyfile, group, "unverified", &_inner_error_);
								_tmp56_ = _tmp55_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								info->unverified = _tmp56_;
							}
							_tmp57_ = g_key_file_has_key (self->priv->keyfile, group, "reply", &_inner_error_);
							_tmp58_ = _tmp57_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp58_) {
								gchar* _tmp59_ = NULL;
								gchar* _tmp60_;
								_tmp59_ = g_key_file_get_string (self->priv->keyfile, group, "reply", &_inner_error_);
								_tmp60_ = _tmp59_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->reply);
								info->reply = _tmp60_;
							}
							_tmp61_ = g_key_file_has_key (self->priv->keyfile, group, "organization", &_inner_error_);
							_tmp62_ = _tmp61_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp62_) {
								gchar* _tmp63_ = NULL;
								gchar* _tmp64_;
								_tmp63_ = g_key_file_get_string (self->priv->keyfile, group, "organization", &_inner_error_);
								_tmp64_ = _tmp63_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->organization);
								info->organization = _tmp64_;
							}
							_tmp65_ = g_key_file_has_key (self->priv->keyfile, group, "signature", &_inner_error_);
							_tmp66_ = _tmp65_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp66_) {
								gchar* _tmp67_ = NULL;
								gchar* _tmp68_;
								_tmp67_ = g_key_file_get_string (self->priv->keyfile, group, "signature", &_inner_error_);
								_tmp68_ = _tmp67_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->signature);
								info->signature = _tmp68_;
							}
							_tmp69_ = g_key_file_has_key (self->priv->keyfile, group, "hide", &_inner_error_);
							_tmp70_ = _tmp69_;
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
							if (_tmp70_) {
								gchar* _tmp71_ = NULL;
								gchar* _tmp72_;
								_tmp71_ = g_key_file_get_string (self->priv->keyfile, group, "hide", &_inner_error_);
								_tmp72_ = _tmp71_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->hide);
								info->hide = _tmp72_;
							}
							{
								gint ftype;
								ftype = 0;
								{
									gboolean _tmp73_;
									_tmp73_ = TRUE;
									while (TRUE) {
										gchar* _tmp74_ = NULL;
										gchar* _tmp75_;
										gchar* _tmp76_;
										gchar* _tmp77_;
										gchar* keyname;
										gboolean _tmp78_;
										gboolean _tmp79_;
										if (!_tmp73_) {
											ftype++;
										}
										_tmp73_ = FALSE;
										if (!(ftype < ((gint) POSTLER_FOLDER_TYPE_MAX))) {
											break;
										}
										_tmp74_ = g_strdup_printf ("%i", ftype);
										_tmp75_ = _tmp74_;
										_tmp76_ = g_strconcat ("localized", _tmp75_, NULL);
										_tmp77_ = _tmp76_;
										_g_free0 (_tmp75_);
										keyname = _tmp77_;
										_tmp78_ = g_key_file_has_key (self->priv->keyfile, group, keyname, &_inner_error_);
										_tmp79_ = _tmp78_;
										if (_inner_error_ != NULL) {
											_g_free0 (keyname);
											_g_object_unref0 (info);
											_g_free0 (type);
											goto __catch15_g_error;
										}
										if (_tmp79_) {
											gchar* _tmp80_ = NULL;
											gchar* _tmp81_;
											gchar* _tmp82_;
											_tmp80_ = g_key_file_get_string (self->priv->keyfile, group, keyname, &_inner_error_);
											_tmp81_ = _tmp80_;
											if (_inner_error_ != NULL) {
												_g_free0 (keyname);
												_g_object_unref0 (info);
												_g_free0 (type);
												goto __catch15_g_error;
											}
											_tmp82_ = _tmp81_;
											_g_free0 (info->folders[ftype]);
											info->folders[ftype] = _tmp82_;
										}
										_g_free0 (keyname);
									}
								}
							}
						} else {
							if (g_strcmp0 (type, "search") == 0) {
								gchar* _tmp83_ = NULL;
								gchar* _tmp84_;
								info->type = POSTLER_ACCOUNT_TYPE_SEARCH;
								_tmp83_ = g_key_file_get_string (self->priv->keyfile, group, "path", &_inner_error_);
								_tmp84_ = _tmp83_;
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
								_g_free0 (info->path);
								info->path = _tmp84_;
							} else {
								const gchar* _tmp85_ = NULL;
								gchar* _tmp86_ = NULL;
								gchar* _tmp87_;
								GError* _tmp88_ = NULL;
								GError* _tmp89_;
								_tmp85_ = _ ("Invalid type \"%s\"");
								_tmp86_ = g_strdup_printf (_tmp85_, type);
								_tmp87_ = _tmp86_;
								_tmp88_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp87_);
								_tmp89_ = _tmp88_;
								_g_free0 (_tmp87_);
								_inner_error_ = _tmp89_;
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
						}
					}
					_tmp90_ = _g_object_ref0 (info);
					self->priv->infos = g_list_prepend (self->priv->infos, _tmp90_);
					_g_object_unref0 (info);
					_g_free0 (type);
				}
				goto __finally15;
				__catch15_g_error:
				{
					GError* _error_ = NULL;
					const gchar* _tmp91_ = NULL;
					_error_ = _inner_error_;
					_inner_error_ = NULL;
					_tmp91_ = _ ("Failed to parse account in \"%s\": %s");
					g_critical (_tmp91_, self->priv->account_file, _error_->message);
					_g_error_free0 (_error_);
				}
				__finally15:
				if (_inner_error_ != NULL) {
					_g_free0 (group);
					group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_free0 (group);
			}
		}
		group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	self->priv->infos = g_list_reverse (self->priv->infos);
	postler_accounts_update_display_names (self);
}


static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


gchar** postler_accounts_get_folders (PostlerAccounts* self, int* result_length1) {
	gchar** result = NULL;
	gchar** _tmp0_ = NULL;
	gchar** folders;
	gint folders_length1;
	gint _folders_size_;
	gchar** _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	folders = _tmp0_;
	folders_length1 = 0;
	_folders_size_ = folders_length1;
	{
		GList* info_collection = NULL;
		GList* info_it = NULL;
		info_collection = self->priv->infos;
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
			PostlerAccountInfo* info = NULL;
			info = (PostlerAccountInfo*) info_it->data;
			{
				if (info->type != POSTLER_ACCOUNT_TYPE_SEARCH) {
					gchar* _tmp1_;
					_tmp1_ = g_strdup (info->path);
					_vala_array_add1 (&folders, &folders_length1, &_folders_size_, _tmp1_);
				}
			}
		}
	}
	_tmp2_ = folders;
	if (result_length1) {
		*result_length1 = folders_length1;
	}
	result = _tmp2_;
	return result;
}


GList* postler_accounts_get_infos (PostlerAccounts* self) {
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->infos;
	return result;
}


static gchar* postler_accounts_get_tool_configfile (PostlerAccounts* self, const gchar* send, PostlerAccountInfo* info, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* cache_dir;
	gchar* _tmp1_;
	gchar* cache_path;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (info != NULL, NULL);
	_tmp0_ = g_get_user_cache_dir ();
	cache_dir = _tmp0_;
	_tmp1_ = g_strconcat (cache_dir, "/postler/mail", NULL);
	cache_path = _tmp1_;
	_tmp2_ = g_mkdir_with_parents (cache_path, 0700);
	if (_tmp2_ != 0) {
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		_tmp3_ = _ ("Cache folder couldn't be created.");
		_tmp4_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp3_);
		_inner_error_ = _tmp4_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (cache_path);
			return NULL;
		} else {
			_g_free0 (cache_path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (send != NULL) {
		gchar* _tmp5_ = NULL;
		_tmp5_ = g_strdup_printf ("%s/%s.msmtprc", cache_path, info->name);
		result = _tmp5_;
		_g_free0 (cache_path);
		return result;
	}
	switch (info->type) {
		case POSTLER_ACCOUNT_TYPE_IMAP:
		{
			gchar* _tmp6_ = NULL;
			_tmp6_ = g_strdup_printf ("%s/%s.mbsyncrc", cache_path, info->name);
			result = _tmp6_;
			_g_free0 (cache_path);
			return result;
		}
		case POSTLER_ACCOUNT_TYPE_MAILDIR:
		case POSTLER_ACCOUNT_TYPE_SEARCH:
		{
			const gchar* _tmp7_ = NULL;
			GError* _tmp8_ = NULL;
			_tmp7_ = _ ("This type can't receive mail.");
			_tmp8_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp7_);
			_inner_error_ = _tmp8_;
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (cache_path);
				return NULL;
			} else {
				_g_free0 (cache_path);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		default:
		break;
	}
	result = NULL;
	_g_free0 (cache_path);
	return result;
}


static gchar* postler_accounts_get_tool_configuration (PostlerAccounts* self, const gchar* send, PostlerAccountInfo* info, GError** error) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* filename;
	struct stat account_file_status = {0};
	struct stat _tmp1_ = {0};
	struct stat filename_status = {0};
	struct stat _tmp2_ = {0};
	gboolean _tmp15_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gchar* _tmp25_;
	gchar* certificate;
	gboolean _tmp26_ = FALSE;
	gchar** _tmp31_;
	gchar** _tmp32_ = NULL;
	gchar** hidden_tmp;
	gint hidden_tmp_length1;
	gint _hidden_tmp_size_;
	gchar* _tmp33_;
	gchar* hidden_folders;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (info != NULL, NULL);
	_tmp0_ = postler_accounts_get_tool_configfile (self, send, info, &_inner_error_);
	filename = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	stat (self->priv->account_file, &_tmp1_);
	account_file_status = _tmp1_;
	stat (filename, &_tmp2_);
	filename_status = _tmp2_;
	if (account_file_status.st_mtime < filename_status.st_mtime) {
		result = filename;
		return result;
	}
	if (self->priv->certificate_file == NULL) {
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		_tmp3_ = _ ("No SSL certificates available");
		_tmp4_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp3_);
		_inner_error_ = _tmp4_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (filename);
			return NULL;
		} else {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (info->address != NULL) {
		gchar** _tmp5_;
		gchar** _tmp6_ = NULL;
		gchar** address_parts;
		gint address_parts_length1;
		gint _address_parts_size_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp12_ = FALSE;
		_tmp6_ = _tmp5_ = g_strsplit_set (info->address, "@,", 3);
		address_parts = _tmp6_;
		address_parts_length1 = _vala_array_length (_tmp5_);
		_address_parts_size_ = address_parts_length1;
		if (address_parts[0] == NULL) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = address_parts[1] == NULL;
		}
		if (_tmp7_) {
			const gchar* _tmp8_ = NULL;
			GError* _tmp9_ = NULL;
			_tmp8_ = _ ("Invalid address");
			_tmp9_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp8_);
			_inner_error_ = _tmp9_;
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				address_parts = (_vala_array_free (address_parts, address_parts_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (filename);
				return NULL;
			} else {
				address_parts = (_vala_array_free (address_parts, address_parts_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		if (send == NULL) {
			_tmp10_ = info->receive == NULL;
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			gchar* _tmp11_;
			_tmp11_ = g_strconcat ("imap.", address_parts[1], NULL);
			_g_free0 (info->receive);
			info->receive = _tmp11_;
		}
		if (send != NULL) {
			_tmp12_ = info->send == NULL;
		} else {
			_tmp12_ = FALSE;
		}
		if (_tmp12_) {
			gchar* _tmp13_;
			_tmp13_ = g_strconcat ("smtp.", address_parts[1], NULL);
			_g_free0 (info->send);
			info->send = _tmp13_;
		}
		if (info->username == NULL) {
			gchar* _tmp14_;
			_tmp14_ = g_strdup (address_parts[0]);
			_g_free0 (info->username);
			info->username = _tmp14_;
		}
		address_parts = (_vala_array_free (address_parts, address_parts_length1, (GDestroyNotify) g_free), NULL);
	}
	if (send == NULL) {
		_tmp15_ = info->receive == NULL;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		const gchar* _tmp16_ = NULL;
		GError* _tmp17_ = NULL;
		_tmp16_ = _ ("Hostname is missing");
		_tmp17_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp16_);
		_inner_error_ = _tmp17_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (filename);
			return NULL;
		} else {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (send != NULL) {
		_tmp18_ = info->send == NULL;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		const gchar* _tmp19_ = NULL;
		GError* _tmp20_ = NULL;
		_tmp19_ = _ ("Hostname is missing");
		_tmp20_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp19_);
		_inner_error_ = _tmp20_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (filename);
			return NULL;
		} else {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (info->username == NULL) {
		const gchar* _tmp21_ = NULL;
		GError* _tmp22_ = NULL;
		_tmp21_ = _ ("Username is missing");
		_tmp22_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp21_);
		_inner_error_ = _tmp22_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (filename);
			return NULL;
		} else {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	if (info->password == NULL) {
		const gchar* _tmp23_ = NULL;
		GError* _tmp24_ = NULL;
		_tmp23_ = _ ("Password is missing");
		_tmp24_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp23_);
		_inner_error_ = _tmp24_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (filename);
			return NULL;
		} else {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp25_ = g_strdup (info->certificate);
	certificate = _tmp25_;
	if (certificate != NULL) {
		gboolean _tmp27_;
		_tmp27_ = g_path_is_absolute (certificate);
		_tmp26_ = !_tmp27_;
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp28_ = g_strconcat (info->path, "/", NULL);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_strconcat (_tmp29_, certificate, NULL);
		_g_free0 (certificate);
		certificate = _tmp30_;
		_g_free0 (_tmp29_);
	}
	_tmp32_ = _tmp31_ = g_strsplit (info->hide, ",", 0);
	hidden_tmp = _tmp32_;
	hidden_tmp_length1 = _vala_array_length (_tmp31_);
	_hidden_tmp_size_ = hidden_tmp_length1;
	_tmp33_ = g_strdup ("");
	hidden_folders = _tmp33_;
	{
		gchar** hidden_collection = NULL;
		gint hidden_collection_length1 = 0;
		gint _hidden_collection_size_ = 0;
		gint hidden_it;
		hidden_collection = hidden_tmp;
		hidden_collection_length1 = hidden_tmp_length1;
		for (hidden_it = 0; hidden_it < hidden_tmp_length1; hidden_it = hidden_it + 1) {
			gchar* _tmp34_;
			gchar* hidden = NULL;
			_tmp34_ = g_strdup (hidden_collection[hidden_it]);
			hidden = _tmp34_;
			{
				gboolean _tmp35_;
				_tmp35_ = string_contains (hidden, " ");
				if (_tmp35_) {
					gchar* _tmp36_ = NULL;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
					gchar* _tmp41_;
					gchar* _tmp42_;
					_tmp36_ = string_replace (hidden, "~-", "/");
					_tmp37_ = _tmp36_;
					_tmp38_ = g_strconcat (" \"!", _tmp37_, NULL);
					_tmp39_ = _tmp38_;
					_tmp40_ = g_strconcat (_tmp39_, "\"", NULL);
					_tmp41_ = _tmp40_;
					_tmp42_ = g_strconcat (hidden_folders, _tmp41_, NULL);
					_g_free0 (hidden_folders);
					hidden_folders = _tmp42_;
					_g_free0 (_tmp41_);
					_g_free0 (_tmp39_);
					_g_free0 (_tmp37_);
				} else {
					gchar* _tmp43_;
					gchar* _tmp44_;
					gchar* _tmp45_;
					_tmp43_ = g_strconcat (" !", hidden, NULL);
					_tmp44_ = _tmp43_;
					_tmp45_ = g_strconcat (hidden_folders, _tmp44_, NULL);
					_g_free0 (hidden_folders);
					hidden_folders = _tmp45_;
					_g_free0 (_tmp44_);
				}
				_g_free0 (hidden);
			}
		}
	}
	if (send != NULL) {
		gchar* tls_options = NULL;
		gint _tmp50_ = 0;
		gchar** _tmp51_;
		gchar** _tmp52_ = NULL;
		gchar** _tmp53_;
		gint _tmp53__length1;
		gchar** _tmp54_;
		gchar** _tmp55_ = NULL;
		gchar** _tmp56_;
		gint _tmp56__length1;
		gchar** _tmp57_;
		gchar** _tmp58_ = NULL;
		gchar** _tmp59_;
		gint _tmp59__length1;
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_;
		gchar* msmtprc;
		if (info->unverified) {
			gchar* _tmp46_;
			_tmp46_ = g_strdup ("tls_certcheck off");
			_g_free0 (tls_options);
			tls_options = _tmp46_;
		} else {
			const gchar* _tmp47_ = NULL;
			gchar* _tmp48_ = NULL;
			if (certificate != NULL) {
				_tmp47_ = certificate;
			} else {
				_tmp47_ = self->priv->certificate_file;
			}
			_tmp48_ = g_strdup_printf ("tls_trust_file %s\ntls_trust_file %s", self->priv->certificate_file, _tmp47_);
			_g_free0 (tls_options);
			tls_options = _tmp48_;
		}
		if (info->send_port == 465) {
			gchar* _tmp49_;
			_tmp49_ = g_strconcat (tls_options, "\ntls_starttls off", NULL);
			_g_free0 (tls_options);
			tls_options = _tmp49_;
		}
		if (info->send_port != 0) {
			_tmp50_ = info->send_port;
		} else {
			_tmp50_ = 25;
		}
		_tmp52_ = _tmp51_ = g_strsplit (info->address, ",", 0);
		_tmp53_ = _tmp52_;
		_tmp53__length1 = _vala_array_length (_tmp51_);
		_tmp55_ = _tmp54_ = g_strsplit (_tmp53_[0], "@", 0);
		_tmp56_ = _tmp55_;
		_tmp56__length1 = _vala_array_length (_tmp54_);
		_tmp58_ = _tmp57_ = g_strsplit (info->address, ",", 0);
		_tmp59_ = _tmp58_;
		_tmp59__length1 = _vala_array_length (_tmp57_);
		_tmp60_ = g_strdup_printf ("\n" \
"                defaults\n" \
"                auth on\n" \
"                tls on\n" \
"                %s\n" \
"                auto_from on\n" \
"                maildomain %s\n" \
"                account postler\n" \
"                host %s\n" \
"                from %s\n" \
"                user %s\n" \
"                password %s\n" \
"                port %d\n" \
"                timeout 90\n" \
"                account default : postler\n" \
"                ", tls_options, _tmp56_[1], info->send, _tmp59_[0], info->username, info->password, _tmp50_);
		_tmp61_ = _tmp60_;
		_tmp59_ = (_vala_array_free (_tmp59_, _tmp59__length1, (GDestroyNotify) g_free), NULL);
		_tmp56_ = (_vala_array_free (_tmp56_, _tmp56__length1, (GDestroyNotify) g_free), NULL);
		_tmp53_ = (_vala_array_free (_tmp53_, _tmp53__length1, (GDestroyNotify) g_free), NULL);
		msmtprc = _tmp61_;
		g_file_set_contents (filename, msmtprc, (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msmtprc);
				_g_free0 (tls_options);
				_g_free0 (hidden_folders);
				hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (certificate);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (msmtprc);
				_g_free0 (tls_options);
				_g_free0 (hidden_folders);
				hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (certificate);
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		g_chmod (filename, 0600);
		result = filename;
		_g_free0 (msmtprc);
		_g_free0 (tls_options);
		_g_free0 (hidden_folders);
		hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (certificate);
		return result;
	}
	switch (info->type) {
		case POSTLER_ACCOUNT_TYPE_IMAP:
		{
			gchar* _tmp62_ = NULL;
			const gchar* _tmp65_ = NULL;
			const gchar* _tmp66_ = NULL;
			gchar* _tmp67_ = NULL;
			gchar* mbsyncrc;
			if (info->prefix != NULL) {
				gchar* _tmp63_;
				_tmp63_ = g_strconcat (info->prefix, ".", NULL);
				_g_free0 (_tmp62_);
				_tmp62_ = _tmp63_;
			} else {
				gchar* _tmp64_;
				_tmp64_ = g_strdup ("");
				_g_free0 (_tmp62_);
				_tmp62_ = _tmp64_;
			}
			if (certificate != NULL) {
				_tmp65_ = "CertificateFile";
			} else {
				_tmp65_ = "";
			}
			if (certificate != NULL) {
				_tmp66_ = certificate;
			} else {
				_tmp66_ = "";
			}
			_tmp67_ = g_strdup_printf ("\n" \
"               Sync Pull\n" \
"               Create Slave\n" \
"               SyncState *\n" \
"\n" \
"               IMAPStore remote\n" \
"                   Host %s\n" \
"                   User %s\n" \
"                   Pass \"%s\"\n" \
"                   Path \"%s\"\n" \
"                   UseIMAPS yes\n" \
"                   CertificateFile %s\n" \
"                   %s %s\n" \
"\n" \
"               MaildirStore local\n" \
"                   Path %s/\n" \
"                   Inbox %s/INBOX\n" \
"\n" \
"               Channel local-remote\n" \
"                   Master :remote:\n" \
"                   Slave :local:\n" \
"                   Patterns %% * !INBOX.*\n" \
"                   Patterns %% %s\n" \
"                   MaxMessages 500\n" \
"\n" \
"               Group mirror\n" \
"                   Channel local-remote:INBOX\n" \
"                   Channel local-remote\n" \
"               ", info->receive, info->username, info->password, _tmp62_, self->priv->certificate_file, _tmp65_, _tmp66_, info->path, info->path, hidden_folders);
			mbsyncrc = _tmp67_;
			g_file_set_contents (filename, mbsyncrc, (gssize) (-1), &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_FILE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (mbsyncrc);
					_g_free0 (_tmp62_);
					_g_free0 (hidden_folders);
					hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (certificate);
					_g_free0 (filename);
					return NULL;
				} else {
					_g_free0 (mbsyncrc);
					_g_free0 (_tmp62_);
					_g_free0 (hidden_folders);
					hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (certificate);
					_g_free0 (filename);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			g_chmod (filename, 0700);
			_g_free0 (mbsyncrc);
			_g_free0 (_tmp62_);
			break;
		}
		case POSTLER_ACCOUNT_TYPE_MAILDIR:
		case POSTLER_ACCOUNT_TYPE_SEARCH:
		{
			const gchar* _tmp68_ = NULL;
			GError* _tmp69_ = NULL;
			_tmp68_ = _ ("Account \"%s\" can't receive mail.");
			_tmp69_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp68_, info->name);
			_inner_error_ = _tmp69_;
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (hidden_folders);
				hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (certificate);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (hidden_folders);
				hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (certificate);
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		default:
		break;
	}
	result = filename;
	_g_free0 (hidden_folders);
	hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (certificate);
	return result;
}


gchar* postler_accounts_get_receive_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error) {
	gchar* result = NULL;
	gchar* command = NULL;
	gint _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (info != NULL, NULL);
	if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
		const gchar* _tmp0_ = NULL;
		const gchar* mbsync;
		gboolean _tmp1_ = FALSE;
		gchar* _tmp2_ = NULL;
		gchar* filename;
		gchar* _tmp3_ = NULL;
		_tmp0_ = g_getenv ("POSTLER_MBSYNC");
		mbsync = _tmp0_;
		if (mbsync == NULL) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = g_strcmp0 (mbsync, "") == 0;
		}
		if (_tmp1_) {
			mbsync = "postler-mbsync";
		}
		_tmp2_ = postler_accounts_get_tool_configuration (self, NULL, info, &_inner_error_);
		filename = _tmp2_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp3_ = g_strdup_printf ("%s -c %s --pull%s mirror", mbsync, filename, " --push --expunge");
		_g_free0 (command);
		command = _tmp3_;
		_g_free0 (filename);
	} else {
		const gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		_tmp4_ = _ ("Account \"%s\" can't receive mail.");
		_tmp5_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp4_, info->name);
		_inner_error_ = _tmp5_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (command);
			return NULL;
		} else {
			_g_free0 (command);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = g_mkdir_with_parents (info->path, 0700);
	if (_tmp6_ != 0) {
		const gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		_tmp7_ = _ ("Mail folder couldn't be created.");
		_tmp8_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp7_);
		_inner_error_ = _tmp8_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (command);
			return NULL;
		} else {
			_g_free0 (command);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = command;
	return result;
}


gchar* postler_accounts_get_fetch_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error) {
	gchar* result = NULL;
	gchar* command = NULL;
	gint _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (info != NULL, NULL);
	if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
		const gchar* _tmp0_ = NULL;
		const gchar* mbsync;
		gboolean _tmp1_ = FALSE;
		gchar* _tmp2_ = NULL;
		gchar* filename;
		gchar* _tmp3_ = NULL;
		_tmp0_ = g_getenv ("POSTLER_MBSYNC");
		mbsync = _tmp0_;
		if (mbsync == NULL) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = g_strcmp0 (mbsync, "") == 0;
		}
		if (_tmp1_) {
			mbsync = "postler-mbsync";
		}
		_tmp2_ = postler_accounts_get_tool_configuration (self, NULL, info, &_inner_error_);
		filename = _tmp2_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp3_ = g_strdup_printf ("%s --list -c %s mirror", mbsync, filename);
		_g_free0 (command);
		command = _tmp3_;
		_g_free0 (filename);
	} else {
		const gchar* _tmp4_ = NULL;
		GError* _tmp5_ = NULL;
		_tmp4_ = _ ("Account \"%s\" can't receive mail.");
		_tmp5_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp4_, info->name);
		_inner_error_ = _tmp5_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (command);
			return NULL;
		} else {
			_g_free0 (command);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = g_mkdir_with_parents (info->path, 0700);
	if (_tmp6_ != 0) {
		const gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		_tmp7_ = _ ("Mail folder couldn't be created.");
		_tmp8_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp7_);
		_inner_error_ = _tmp8_;
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (command);
			return NULL;
		} else {
			_g_free0 (command);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = command;
	return result;
}


gchar* postler_accounts_get_send_command (PostlerAccounts* self, PostlerAccountInfo* info, const gchar* send, GError** error) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* filename;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* command;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (info != NULL, NULL);
	g_return_val_if_fail (send != NULL, NULL);
	_tmp0_ = postler_accounts_get_tool_configuration (self, send, info, &_inner_error_);
	filename = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = g_getenv ("SHELL");
	_tmp2_ = g_strdup_printf ("%s -c 'cat \"%s\" | msmtp -C %s -t'", _tmp1_, send, filename);
	command = _tmp2_;
	result = command;
	_g_free0 (filename);
	return result;
}


static void postler_accounts_real_add_info (PostlerAccounts* self, PostlerAccountInfo* info) {
	PostlerAccountInfo* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
		gchar* _tmp0_;
		_tmp0_ = g_strconcat (self->priv->data_path, info->name, NULL);
		_g_free0 (info->path);
		info->path = _tmp0_;
	}
	_tmp1_ = _g_object_ref0 (info);
	self->priv->infos = g_list_append (self->priv->infos, _tmp1_);
	postler_accounts_update (self);
}


static void postler_accounts_real_remove_info (PostlerAccounts* self, PostlerAccountInfo* info) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	self->priv->infos = g_list_remove (self->priv->infos, info);
	postler_accounts_delete_account (self, info);
}


static void postler_accounts_class_init (PostlerAccountsClass * klass) {
	postler_accounts_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PostlerAccountsPrivate));
	POSTLER_ACCOUNTS_CLASS (klass)->add_info = postler_accounts_real_add_info;
	POSTLER_ACCOUNTS_CLASS (klass)->remove_info = postler_accounts_real_remove_info;
	G_OBJECT_CLASS (klass)->finalize = postler_accounts_finalize;
	g_signal_new ("add_info", POSTLER_TYPE_ACCOUNTS, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PostlerAccountsClass, add_info), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POSTLER_TYPE_ACCOUNT_INFO);
	g_signal_new ("remove_info", POSTLER_TYPE_ACCOUNTS, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PostlerAccountsClass, remove_info), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POSTLER_TYPE_ACCOUNT_INFO);
}


static void postler_accounts_instance_init (PostlerAccounts * self) {
	self->priv = POSTLER_ACCOUNTS_GET_PRIVATE (self);
}


static void postler_accounts_finalize (GObject* obj) {
	PostlerAccounts * self;
	self = POSTLER_ACCOUNTS (obj);
	_g_free0 (self->priv->config_path);
	_g_free0 (self->priv->account_file);
	_g_free0 (self->priv->data_path);
	_g_free0 (self->priv->certificate_file);
	_g_key_file_free0 (self->priv->keyfile);
	__g_list_free__g_object_unref0_0 (self->priv->infos);
	G_OBJECT_CLASS (postler_accounts_parent_class)->finalize (obj);
}


GType postler_accounts_get_type (void) {
	static volatile gsize postler_accounts_type_id__volatile = 0;
	if (g_once_init_enter (&postler_accounts_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PostlerAccountsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) postler_accounts_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PostlerAccounts), 0, (GInstanceInitFunc) postler_accounts_instance_init, NULL };
		GType postler_accounts_type_id;
		postler_accounts_type_id = g_type_register_static (G_TYPE_OBJECT, "PostlerAccounts", &g_define_type_info, 0);
		g_once_init_leave (&postler_accounts_type_id__volatile, postler_accounts_type_id);
	}
	return postler_accounts_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



