/* postler-state.c generated by valac 0.13.1, the Vala compiler
 * generated from postler-state.vala, do not modify */

/*
 Copyright (C) 2011 Sergio Spinatelli <spinatelli.sergio@gmail.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>


#define POSTLER_TYPE_STATE (postler_state_get_type ())
#define POSTLER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POSTLER_TYPE_STATE, PostlerState))
#define POSTLER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POSTLER_TYPE_STATE, PostlerStateClass))
#define POSTLER_IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POSTLER_TYPE_STATE))
#define POSTLER_IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POSTLER_TYPE_STATE))
#define POSTLER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POSTLER_TYPE_STATE, PostlerStateClass))

typedef struct _PostlerState PostlerState;
typedef struct _PostlerStateClass PostlerStateClass;
typedef struct _PostlerStatePrivate PostlerStatePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PostlerState {
	GObject parent_instance;
	PostlerStatePrivate * priv;
};

struct _PostlerStateClass {
	GObjectClass parent_class;
};

struct _PostlerStatePrivate {
	gchar* config_path;
	gchar* state_file;
	gchar* group;
	GKeyFile* keyfile;
	gint _width;
	gint _height;
	gint _window_state;
	gchar* _open_folder;
};


static gpointer postler_state_parent_class = NULL;

GType postler_state_get_type (void) G_GNUC_CONST;
#define POSTLER_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POSTLER_TYPE_STATE, PostlerStatePrivate))
enum  {
	POSTLER_STATE_DUMMY_PROPERTY,
	POSTLER_STATE_WIDTH,
	POSTLER_STATE_HEIGHT,
	POSTLER_STATE_WINDOW_STATE,
	POSTLER_STATE_OPEN_FOLDER
};
PostlerState* postler_state_new (void);
PostlerState* postler_state_construct (GType object_type);
static void postler_state_reload (PostlerState* self);
static void postler_state_write_keyfile (PostlerState* self, GError** error);
void postler_state_update (PostlerState* self);
gint postler_state_get_width (PostlerState* self);
gint postler_state_get_height (PostlerState* self);
gint postler_state_get_window_state (PostlerState* self);
const gchar* postler_state_get_open_folder (PostlerState* self);
void postler_state_set_width (PostlerState* self, gint value);
void postler_state_set_height (PostlerState* self, gint value);
void postler_state_set_window_state (PostlerState* self, gint value);
void postler_state_set_open_folder (PostlerState* self, const gchar* value);
static void postler_state_finalize (GObject* obj);
static void _vala_postler_state_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_postler_state_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


PostlerState* postler_state_construct (GType object_type) {
	PostlerState * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* config_dir;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	self = (PostlerState*) g_object_new (object_type, NULL);
	_tmp0_ = g_get_user_config_dir ();
	config_dir = _tmp0_;
	_tmp1_ = g_strconcat (config_dir, "/", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, PACKAGE_NAME, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, "/", NULL);
	_g_free0 (self->priv->config_path);
	self->priv->config_path = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp6_ = g_strconcat (self->priv->config_path, "staterc", NULL);
	_g_free0 (self->priv->state_file);
	self->priv->state_file = _tmp6_;
	postler_state_reload (self);
	return self;
}


PostlerState* postler_state_new (void) {
	return postler_state_construct (POSTLER_TYPE_STATE);
}


static void postler_state_write_keyfile (PostlerState* self, GError** error) {
	gint _tmp0_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_mkdir_with_parents (self->priv->config_path, 0700);
	if (_tmp0_ != 0) {
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		_tmp1_ = _ ("Config folder couldn't be created.");
		_tmp2_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp1_);
		_inner_error_ = _tmp2_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = g_key_file_to_data (self->priv->keyfile, NULL, NULL);
	_tmp4_ = _tmp3_;
	g_file_set_contents (self->priv->state_file, _tmp4_, (gssize) (-1), &_inner_error_);
	_g_free0 (_tmp4_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


void postler_state_update (PostlerState* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		g_key_file_set_integer (self->priv->keyfile, self->priv->group, "width", self->priv->_width);
		g_key_file_set_integer (self->priv->keyfile, self->priv->group, "height", self->priv->_height);
		g_key_file_set_integer (self->priv->keyfile, self->priv->group, "window-state", self->priv->_window_state);
		g_key_file_set_string (self->priv->keyfile, self->priv->group, "open-folder", self->priv->_open_folder);
		postler_state_write_keyfile (self, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch73_g_error;
		}
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		g_critical ("postler-state.vala:45: Failed to save \"%s\": %s", self->priv->state_file, _error_->message);
		_g_error_free0 (_error_);
	}
	__finally73:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void postler_state_reload (PostlerState* self) {
	GKeyFile* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_key_file_new ();
	_g_key_file_free0 (self->priv->keyfile);
	self->priv->keyfile = _tmp0_;
	{
		g_key_file_load_from_file (self->priv->keyfile, self->priv->state_file, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch74_g_error;
		}
	}
	goto __finally74;
	__catch74_g_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		g_debug ("postler-state.vala:55: Failed to load \"%s\": %s", self->priv->state_file, _error_->message);
		_g_error_free0 (_error_);
	}
	__finally74:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		gboolean _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp1_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "width", &_inner_error_);
		_tmp2_ = _tmp1_;
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
		if (_tmp2_) {
			gint _tmp3_;
			gint _tmp4_;
			_tmp3_ = g_key_file_get_integer (self->priv->keyfile, self->priv->group, "width", &_inner_error_);
			_tmp4_ = _tmp3_;
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
			postler_state_set_width (self, _tmp4_);
		}
		_tmp5_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "height", &_inner_error_);
		_tmp6_ = _tmp5_;
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
		if (_tmp6_) {
			gint _tmp7_;
			gint _tmp8_;
			_tmp7_ = g_key_file_get_integer (self->priv->keyfile, self->priv->group, "height", &_inner_error_);
			_tmp8_ = _tmp7_;
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
			postler_state_set_height (self, _tmp8_);
		}
		_tmp9_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "window-state", &_inner_error_);
		_tmp10_ = _tmp9_;
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
		if (_tmp10_) {
			gint _tmp11_;
			gint _tmp12_;
			_tmp11_ = g_key_file_get_integer (self->priv->keyfile, self->priv->group, "window-state", &_inner_error_);
			_tmp12_ = _tmp11_;
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
			postler_state_set_window_state (self, _tmp12_);
		}
		_tmp13_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "open-folder", &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
		if (_tmp14_) {
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp15_ = g_key_file_get_string (self->priv->keyfile, self->priv->group, "open-folder", &_inner_error_);
			_tmp16_ = _tmp15_;
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
			_tmp17_ = _tmp16_;
			postler_state_set_open_folder (self, _tmp17_);
			_g_free0 (_tmp17_);
		}
	}
	goto __finally75;
	__catch75_g_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp18_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp18_ = _ ("Failed to parse state in \"%s\": %s");
		g_critical (_tmp18_, self->priv->state_file, _error_->message);
		_g_error_free0 (_error_);
	}
	__finally75:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


gint postler_state_get_width (PostlerState* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_width;
	return result;
}


void postler_state_set_width (PostlerState* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_width = value;
	g_object_notify ((GObject *) self, "width");
}


gint postler_state_get_height (PostlerState* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_height;
	return result;
}


void postler_state_set_height (PostlerState* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_height = value;
	g_object_notify ((GObject *) self, "height");
}


gint postler_state_get_window_state (PostlerState* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_window_state;
	return result;
}


void postler_state_set_window_state (PostlerState* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_window_state = value;
	g_object_notify ((GObject *) self, "window-state");
}


const gchar* postler_state_get_open_folder (PostlerState* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_open_folder;
	return result;
}


void postler_state_set_open_folder (PostlerState* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_open_folder);
	self->priv->_open_folder = _tmp0_;
	g_object_notify ((GObject *) self, "open-folder");
}


static void postler_state_class_init (PostlerStateClass * klass) {
	postler_state_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PostlerStatePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_postler_state_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_postler_state_set_property;
	G_OBJECT_CLASS (klass)->finalize = postler_state_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_WIDTH, g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_HEIGHT, g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_WINDOW_STATE, g_param_spec_int ("window-state", "window-state", "window-state", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_OPEN_FOLDER, g_param_spec_string ("open-folder", "open-folder", "open-folder", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void postler_state_instance_init (PostlerState * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = POSTLER_STATE_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("state");
	self->priv->group = _tmp0_;
	self->priv->_width = 0;
	self->priv->_height = 0;
	self->priv->_window_state = 0;
	_tmp1_ = g_strdup ("");
	self->priv->_open_folder = _tmp1_;
}


static void postler_state_finalize (GObject* obj) {
	PostlerState * self;
	self = POSTLER_STATE (obj);
	_g_free0 (self->priv->config_path);
	_g_free0 (self->priv->state_file);
	_g_free0 (self->priv->group);
	_g_key_file_free0 (self->priv->keyfile);
	_g_free0 (self->priv->_open_folder);
	G_OBJECT_CLASS (postler_state_parent_class)->finalize (obj);
}


GType postler_state_get_type (void) {
	static volatile gsize postler_state_type_id__volatile = 0;
	if (g_once_init_enter (&postler_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PostlerStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) postler_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PostlerState), 0, (GInstanceInitFunc) postler_state_instance_init, NULL };
		GType postler_state_type_id;
		postler_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PostlerState", &g_define_type_info, 0);
		g_once_init_leave (&postler_state_type_id__volatile, postler_state_type_id);
	}
	return postler_state_type_id__volatile;
}


static void _vala_postler_state_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PostlerState * self;
	self = POSTLER_STATE (object);
	switch (property_id) {
		case POSTLER_STATE_WIDTH:
		g_value_set_int (value, postler_state_get_width (self));
		break;
		case POSTLER_STATE_HEIGHT:
		g_value_set_int (value, postler_state_get_height (self));
		break;
		case POSTLER_STATE_WINDOW_STATE:
		g_value_set_int (value, postler_state_get_window_state (self));
		break;
		case POSTLER_STATE_OPEN_FOLDER:
		g_value_set_string (value, postler_state_get_open_folder (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_postler_state_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PostlerState * self;
	self = POSTLER_STATE (object);
	switch (property_id) {
		case POSTLER_STATE_WIDTH:
		postler_state_set_width (self, g_value_get_int (value));
		break;
		case POSTLER_STATE_HEIGHT:
		postler_state_set_height (self, g_value_get_int (value));
		break;
		case POSTLER_STATE_WINDOW_STATE:
		postler_state_set_window_state (self, g_value_get_int (value));
		break;
		case POSTLER_STATE_OPEN_FOLDER:
		postler_state_set_open_folder (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



